using System;
using Collections=System.Collections;

namespace VarekartotekApplication
{
	public class VareGateway
	{
    private static System.Collections.IDictionary cache = 
                      new System.Collections.Hashtable();

    private static System.Data.IDbConnection getConnection()
    {
      System.Data.IDbConnection con = DatabaseGateway.getConnection();
      con.Open();
      return con;
    }

    public  static Collections.ArrayList GetAlleVarer ()
    { 
      Collections.ArrayList varer = new 
			      Collections.ArrayList();
      System.Data.IDbConnection con = getConnection();
      System.Data.IDbCommand cmd = con.CreateCommand();
      System.Data.IDataReader dataReader; 
      cmd.CommandText = "SELECT * FROM Vare";
      dataReader = cmd.ExecuteReader();
      while ( dataReader.Read() )
      {
        Vare enVare;
        int id = int.Parse(dataReader["ID"].ToString());
        if (cache.Contains(id))  /* findes i cache */
          enVare = (Vare)cache[id]; /* hent vare fra cache */
        else 
        {
          enVare = new VareImplDb (id,
                    int.Parse(dataReader["Varenr"].ToString()),
                    dataReader["Betegnelse"].ToString(),
                    int.Parse(dataReader["AntalPaaLager"].ToString()),
                    float.Parse(dataReader["SalgsEnhedsPris"].ToString())
                    ); /* slut p new */
          cache.Add(id, enVare);
        }
        varer.Add(enVare);
      }
      dataReader.Close(); /* luk foresprsel*/
      con.Close();
      return varer;
    }

    public  static Vare FindVare (int varenr)
    { 
      Vare enVare = null;
      System.Data.IDbConnection con = getConnection();
      System.Data.IDbCommand cmd = con.CreateCommand();
      System.Data.IDataReader dataReader; 
      cmd.CommandText = "SELECT * FROM Vare"
					      +" WHERE Varenr="+varenr;
      dataReader = cmd.ExecuteReader();
      if ( dataReader.Read() )
      {
        int id = int.Parse(dataReader["ID"].ToString());
        if (cache.Contains(id))  /* findes i cache */
          enVare = (Vare)cache[id]; /* hent vare fra cache */
        else 
        {
          enVare = new VareImplDb (id,
                    int.Parse(dataReader["Varenr"].ToString()),
                    dataReader["Betegnelse"].ToString(),
                    int.Parse(dataReader["AntalPaaLager"].ToString()),
                    float.Parse(dataReader["SalgsEnhedsPris"].ToString())
                    ); /* slut p new */
          cache.Add(id, enVare);
        }
      }
      dataReader.Close(); /* luk foresprsel*/
      con.Close();
      return enVare;
    }

    public  static Vare OpretVare (int varenr, string betegnelse,
	    int antalPLager, float salgsEnhedsPris)
    { 
      System.Data.IDbConnection con = getConnection();
      System.Data.IDbCommand cmd = con.CreateCommand();
      int antalIndsat;
      cmd.CommandText = "INSERT INTO Vare "
	      + " (Varenr, Betegnelse, AntalPaaLager, SalgsEnhedsPris)"
	      + " VALUES"
	      + " ("+varenr+",'"+betegnelse+"',"
	      +antalPLager+","+
	      salgsEnhedsPris.ToString().Replace(',','.')
	      + ")";
      antalIndsat = cmd.ExecuteNonQuery(); /* udfr SQL Update/Insert/Delete  */
      con.Close();
      /* Hent varen ind i memory fra DB*/
      return FindVare(varenr);
    }
    public  static void RetVareBetegnelse (int id, string betegnelse)
    { 
      System.Data.IDbConnection con = getConnection();
      System.Data.IDbCommand cmd = con.CreateCommand();
      int antalRettet;
      cmd.CommandText = "UPDATE Vare SET"
	      +" Betegnelse='"+betegnelse+"'"
	      +" WHERE ID="+id;
      antalRettet = cmd.ExecuteNonQuery(); /* udfr SQL Update/Insert/Delete  */
      con.Close();
    }
    public  static void RetSalgsEnhedsPris (int id, float salgsEnhedsPris)
    { 
      System.Data.IDbConnection con = getConnection();
      System.Data.IDbCommand cmd = con.CreateCommand();
      int antalRettet;
      cmd.CommandText = "UPDATE Vare SET"
	      +" SalgsEnhedsPris="+salgsEnhedsPris.ToString().Replace(',','.')
	      +" WHERE ID="+id;
      antalRettet = cmd.ExecuteNonQuery(); /* udfr SQL Update/Insert/Delete  */
      con.Close();
    }
    public  static void RetAntalPLager (int id, int antalPLager)
    { 
      System.Data.IDbConnection con = getConnection();
      System.Data.IDbCommand cmd = con.CreateCommand();
      int antalRettet;
      cmd.CommandText = "UPDATE Vare SET"
	      +" AntalPaaLager="+antalPLager
	      +" WHERE ID="+id;
      antalRettet = cmd.ExecuteNonQuery(); /* udfr SQL Update/Insert/Delete  */
      con.Close();
    }
  }
}
